'Declare shell objects 
Set objShell = CreateObject("Shell.Application") 
Set WshShell = CreateObject("WScript.Shell") 
Set objFSO = CreateObject("Scripting.FileSystemObject")   
 
'Excel object for printing workbooks 
Set Excel = WScript.CreateObject("Excel.Application") 
 
'Get start directory from user 
path = InputBox("Please enter a path:") 
 
If path <> "" Then 
    'Get directory object & items 
    Set objFolder = objFSO.GetFolder(path) 
    Set shFolder = objShell.Namespace(path) 
    Set colItems = shFolder.Items 
 
    'Iterate through items collection, printing documents 
    For i = 0 To colItems.Count - 1 
    'Grab extension 
    str = Right(colItems.Item(i).Name, 4) 
 
    'Print Word documents, Visio drawings and PDFs using InvokeVerbEx("Print") 
        If str = ".doc" Or str = ".vsd" Or _ 
                str = ".pdf" Then 
        colItems.Item(i).InvokeVerbEx("Print") 
    End If 
 
    'Print a full workbook by iterating through worksheets 
    If str = ".xls" Then 
        'Set the workbook object by passing the full path to method Open 
        Set workbook = Excel.Workbooks.Open(path & hfis(ai) & _ 
        "\" & colItems.Item(i).Name,false,true) 
         
        'Print all non-blank worksheets iteratively 
        For Each ws In workbook.Sheets 
            ws.Printout 
        Next 
        workbook.Close     
    End If 
     
    'Print JPEGs 'silently' by passing them to Picture and Fax Viewer via command.com 
    If str = ".jpg" Then 
        'Resolve the long path into a short, DOS-compatible path 
        str = WScript.CreateObject("Scripting.FileSystemObject").GetFile(path & hfis(ai) & _ 
        "\" & colItems.Item(i).Name).ShortPath 
 
        'Pass file to Paint 
        WshShell.Run "rundll32 C:\WINDOWS\system32\shimgvw.dll,ImageView_PrintTo /pt " & str 
    End If 
Next 
     
    '* RECURSE THROUGH SUBDIRECTORIES * 
 
    PrintSubfolders objFSO.GetFolder(path) 
 
    Sub PrintSubFolders(subDir) 
        For Each sd In subDir.SubFolders 
            Set sdFolder = objShell.Namespace(sd.Path) 
            Set colItems = sdFolder.Items 
  
            For i = 0 To colItems.Count - 1 
            str = Right(colItems.Item(i).Name, 4) 
                If str = ".doc" Or str = ".vsd" Or _ 
                    str = ".pdf" Then 
                colItems.Item(i).InvokeVerbEx("Print") 
            End If 
            If str = ".xls" Then 
                Set workbook = Excel.Workbooks.Open(sd.Path & _ 
            "\" & colItems.Item(i).Name,false,true) 
         
                For Each ws In workbook.Sheets 
                    ws.Printout 
                Next 
                workbook.Close     
            End If 
            If str = ".jpg" Then 
            str = WScript.CreateObject("Scripting.FileSystemObject").GetFile(sd.Path & _ 
            "\" & colItems.Item(i).Name).ShortPath 
                WshShell.Run "rundll32 C:\WINDOWS\system32\shimgvw.dll,ImageView_PrintTo /pt " & str 
            End If 
            Next 
 
            PrintSubFolders sd 
        Next 
    End Sub 
    MsgBox("Done.") 
Else 'User pressed Cancel 
    MsgBox("Cancelled.") 
End If